/* WorkPlaceCoreTemp v0.2 */
parse arg parameter
parse source . . ScriptFile

icon=filespec("D", ScriptFile)||filespec("P", ScriptFile)||'WPCT.ico'

object_id = "<WP_CoreTemp>"


/* error handler */
signal on Error NAME error
signal on syntax NAME error
signal on FAILURE name error
signal on Halt name error



if rxfuncquery('SysLoadFuncs') then do
 call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
 call SysLoadFuncs
end


if rxfuncquery('rxuinit') then do
 Call RxFuncAdd 'rxuinit','rxu','rxuinit'
 Call rxuinit
end

/* named-pipe server setup */
pipename = '\PIPE\CORETEMP'
openmode = 'WIN'
pipemode = 'WTR'
instance_count = 1
outbuf = 128
inbuf = 128
timeout = -1
readbufsize = 128

/* create or upgrade object */
targetfolder = "<WP_DESKTOP>"


address cmd '@start "CoreTemp Driver" /MIN /B /C  coretemp.exe -s'


do forever

dosrc = rxcreatenpipe('hpipe',pipename,openmode,pipemode,instance_count,outbuf,inbuf,timeout)
if dosrc <> 0 then
  do
  say 'RxCreateNPipe failed with rc =' dosrc
  exit
  end

dosrc = rxconnectnpipe(hpipe)
if dosrc <> 0 then
  do
  say 'RxConnectNPipe failed with rc =' dosrc
  exit
  end


dosrc = rxread('data',hpipe,readbufsize)

parse var data . ':' coretemp1 '/' coretemp2  '/'  coretemp3 '/' coretemp4 '/' coretemp5 '/' coretemp6


coretemp_obj_string="Core Temperature:"

if coretemp1 >< "" then coretemp_obj_string=coretemp_obj_string||'0d0a'x||"Core 1: " || right(strip(strip(coretemp1),'T','*'),2,"0")||"C"
if coretemp2 >< "" then coretemp_obj_string=coretemp_obj_string||'0d0a'x||"Core 2: " || right(strip(coretemp2,'T','*'),2,"0")||"C"
if coretemp3 >< "" then coretemp_obj_string=coretemp_obj_string||'0d0a'x||"Core 3: " || right(strip(coretemp3,'T','*'),2,"0")||"C"
if coretemp4 >< "" then coretemp_obj_string=coretemp_obj_string||'0d0a'x||"Core 4: " || right(strip(coretemp4,'T','*'),2,"0")||"C"
if coretemp5 >< "" then coretemp_obj_string=coretemp_obj_string||'0d0a'x||"Core 5: " || right(strip(coretemp5,'T','*'),2,"0")||"C"
if coretemp6 >< "" then coretemp_obj_string=coretemp_obj_string||'0d0a'x||"Core 6: " || right(strip(coretemp6,'T','*'),2,"0")||"C"


objecttext = coretemp_obj_string

if data >< "" then call SysCreateObject 'WPProgram',objecttext,targetfolder,'OBJECTID='||object_id||';EXENAME='||ScriptFile||';TITLE='||objecttext||';ICONFILE='||icon||';','Update'

call rxcloseh hpipe


end /* forever */


error:
exit
